#ifndef _MAP_HPP
#define _MAP_HPP
#include<allegro.h>
#include"fractal.hpp"

#define loc_plains 0
//#define loc_small_province 1
//#define loc_large_province 2
#define loc_sea 4
//#define loc_fresh_water 8
#define loc_mountain 16
#define loc_swamp 32
#define loc_waste 64
#define loc_forest 128
#define loc_farm 256
//#define loc_no_start 512
//#define loc_many_sites 1024
#define loc_deep_sea 2048
#define loc_cave 4096
//#define loc_fire_site 8192
//#define loc_air_site 16384
//#define loc_water_site 32768
//#define loc_earth_site 65536
//#define loc_astral_site 131072
//#define loc_death_site 262144
//#define loc_nature_site 524288
//#define loc_blood_site 1048576
//#define loc_holy_site 2097152
//#define loc_border_mountain 4194304

class Map
{
    private:
        float **maps;
        int *locmap;
        int size;
        float max1,max2;
        float min1,min2;
        int width;
        int height;
        BITMAP *image;
        int deep_ocean;
        int ocean;
        int mountain;
        int wasteland;
        int farmlands;
        int forest;
        int marsh;
        void StandardizeValuess();
        void GetMaxMins();
        void GenerateLocMap();

    public:
        Map(int size,int width,int height,int deep_ocean,int ocean,int mountain,int wasteland,int farmlands,int forest,int marsh):
        size(size),width(width),height(height),deep_ocean(deep_ocean),ocean(ocean),mountain(mountain),wasteland(wasteland),farmlands(farmlands),forest(forest),marsh(marsh){}
        void GenerateMaps();
        void CreateMapImage();

        void DrawMap(BITMAP *target);

        void DumpImage();
};

#endif
